Openembedded Core Discussions
 help / color / mirror / Atom feed
* [PATCH 0/2] kernel module fixes
@ 2013-02-28 18:09 Mark Hatle
  2013-02-28 18:09 ` [PATCH 1/2] kernel.bbclass: Add missing modules.order and modules.builtins Mark Hatle
  2013-02-28 18:09 ` [PATCH 2/2] module.bbclass: Create a new depmodwrapper to assist cross-installs Mark Hatle
  0 siblings, 2 replies; 8+ messages in thread
From: Mark Hatle @ 2013-02-28 18:09 UTC (permalink / raw)
  To: openembedded-core

There are two patches in this set, they address two different, but related
problems.

The first patch likely needs some discussion before it can be accepted.  This
fixes the issue, but we're not sure that putting these two files into the
kernel-base package is the right answer.

The second patch adds a new depmodwrapper, that resolves the issue.  This fix
was suggested by Richard.  I think it's a reasonable solution and in all of my
testing it has resolved the problem.  (Without the first patch, you will get
warnings about the missing files, but that first patch is not required for
this one to work.)



^ permalink raw reply	[flat|nested] 8+ messages in thread

* [PATCH 1/2] kernel.bbclass: Add missing modules.order and modules.builtins
  2013-02-28 18:09 [PATCH 0/2] kernel module fixes Mark Hatle
@ 2013-02-28 18:09 ` Mark Hatle
  2013-02-28 18:09 ` [PATCH 2/2] module.bbclass: Create a new depmodwrapper to assist cross-installs Mark Hatle
  1 sibling, 0 replies; 8+ messages in thread
From: Mark Hatle @ 2013-02-28 18:09 UTC (permalink / raw)
  To: openembedded-core

When running depmod, from kmod, warnings about missing modules.order
and modules.builtins occur.  Looking back it is not clear why these
files were being ignored, other then nobody knew what to do with them.

Add the files into the kernel-base package, if they exist, ensuring
they will always get installed if at least one module is installed.

[ YOCTO #3963 ]

Signed-off-by: Mark Hatle <mark.hatle@windriver.com>
Signed-off-by: Bruce Ashfield <bruce.ashfield@windriver.com>
---
 meta/classes/kernel.bbclass |    3 +--
 1 files changed, 1 insertions(+), 2 deletions(-)

diff --git a/meta/classes/kernel.bbclass b/meta/classes/kernel.bbclass
index 00117a6..e8c585b 100644
--- a/meta/classes/kernel.bbclass
+++ b/meta/classes/kernel.bbclass
@@ -94,8 +94,6 @@ kernel_do_install() {
 	unset CFLAGS CPPFLAGS CXXFLAGS LDFLAGS MACHINE
 	if (grep -q -i -e '^CONFIG_MODULES=y$' .config); then
 		oe_runmake DEPMOD=echo INSTALL_MOD_PATH="${D}" modules_install
-		rm -f "${D}/lib/modules/${KERNEL_VERSION}/modules.order"
-		rm -f "${D}/lib/modules/${KERNEL_VERSION}/modules.builtin"
 		rm "${D}/lib/modules/${KERNEL_VERSION}/build"
 		rm "${D}/lib/modules/${KERNEL_VERSION}/source"
 	else
@@ -251,6 +249,7 @@ EXPORT_FUNCTIONS do_compile do_install do_configure
 # kernel-image becomes kernel-image-${KERNEL_VERISON}
 PACKAGES = "kernel kernel-base kernel-vmlinux kernel-image kernel-dev kernel-modules"
 FILES = ""
+FILES_kernel-base = "/lib/modules/${KERNEL_VERSION}/modules.order /lib/modules/${KERNEL_VERSION}/modules.builtin"
 FILES_kernel-image = "/boot/${KERNEL_IMAGETYPE}*"
 FILES_kernel-dev = "/boot/System.map* /boot/Module.symvers* /boot/config* ${KERNEL_SRC_PATH}"
 FILES_kernel-vmlinux = "/boot/vmlinux*"
-- 
1.7.1




^ permalink raw reply related	[flat|nested] 8+ messages in thread

* [PATCH 2/2] module.bbclass: Create a new depmodwrapper to assist cross-installs
  2013-02-28 18:09 [PATCH 0/2] kernel module fixes Mark Hatle
  2013-02-28 18:09 ` [PATCH 1/2] kernel.bbclass: Add missing modules.order and modules.builtins Mark Hatle
@ 2013-02-28 18:09 ` Mark Hatle
  2013-02-28 19:12   ` Bruce Ashfield
  2013-02-28 20:53   ` Richard Purdie
  1 sibling, 2 replies; 8+ messages in thread
From: Mark Hatle @ 2013-02-28 18:09 UTC (permalink / raw)
  To: openembedded-core

Previously the build path to STAGING_KERNEL_DIR was being embedded into the
package post install scripts.  We avoid this behavior by generating a special
depmodwrapper script.  This script contains that hard-coded path, ensuring
that re-use of the sstate-cache (and/or packages) will always run through the
wrapper generated by the current build with a checksum that includes
STAGING_KERNEL_DIR.

[ YOCTO #3962 ]

Signed-off-by: Mark Hatle <mark.hatle@windriver.com>
Signed-off-by: Bruce Ashfield <bruce.ashfield@windriver.com>
---
 meta/classes/image.bbclass                         |    4 +-
 meta/classes/kernel.bbclass                        |    8 ++--
 meta/classes/module.bbclass                        |    4 +-
 .../recipes-kernel/kmod/depmodwrapper-cross_1.0.bb |   34 ++++++++++++++++++++
 4 files changed, 42 insertions(+), 8 deletions(-)
 create mode 100644 meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb

diff --git a/meta/classes/image.bbclass b/meta/classes/image.bbclass
index dd78acb..af17331 100644
--- a/meta/classes/image.bbclass
+++ b/meta/classes/image.bbclass
@@ -10,7 +10,7 @@ inherit gzipnative
 
 LICENSE = "MIT"
 PACKAGES = ""
-DEPENDS += "${MLPREFIX}qemuwrapper-cross"
+DEPENDS += "${MLPREFIX}qemuwrapper-cross depmodwrapper-cross"
 RDEPENDS += "${IMAGE_INSTALL} ${LINGUAS_INSTALL} ${NORMAL_FEATURE_INSTALL} ${ROOTFS_BOOTSTRAP_INSTALL}"
 RRECOMMENDS += "${NORMAL_FEATURE_INSTALL_OPTIONAL}"
 
@@ -283,7 +283,7 @@ fakeroot do_rootfs () {
 		KERNEL_VERSION=`cat ${STAGING_KERNEL_DIR}/kernel-abiversion`
 
 		mkdir -p ${IMAGE_ROOTFS}/lib/modules/$KERNEL_VERSION
-		depmod -a -b ${IMAGE_ROOTFS} -F ${STAGING_KERNEL_DIR}/System.map-$KERNEL_VERSION $KERNEL_VERSION
+		depmodwrapper -a -b ${IMAGE_ROOTFS} $KERNEL_VERSION
 	fi
 
 	${IMAGE_PREPROCESS_COMMAND}
diff --git a/meta/classes/kernel.bbclass b/meta/classes/kernel.bbclass
index e8c585b..2bdc2fc 100644
--- a/meta/classes/kernel.bbclass
+++ b/meta/classes/kernel.bbclass
@@ -1,7 +1,7 @@
 inherit linux-kernel-base module_strip
 
 PROVIDES += "virtual/kernel"
-DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native"
+DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native depmodwrapper-cross"
 
 # we include gcc above, we dont need virtual/libc
 INHIBIT_DEFAULT_DEPS = "1"
@@ -272,7 +272,7 @@ if [ ! -e "$D/lib/modules/${KERNEL_VERSION}" ]; then
 	mkdir -p $D/lib/modules/${KERNEL_VERSION}
 fi
 if [ -n "$D" ]; then
-	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
+	depmodwrapper -a -b $D ${KERNEL_VERSION}
 else
 	depmod -a ${KERNEL_VERSION}
 fi
@@ -282,7 +282,7 @@ pkg_postinst_modules () {
 if [ -z "$D" ]; then
 	depmod -a ${KERNEL_VERSION}
 else
-	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
+	depmodwrapper -a -b $D ${KERNEL_VERSION}
 fi
 }
 
@@ -290,7 +290,7 @@ pkg_postrm_modules () {
 if [ -z "$D" ]; then
 	depmod -a ${KERNEL_VERSION}
 else
-	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
+	depmodwrapper -a -b $D ${KERNEL_VERSION}
 fi
 }
 
diff --git a/meta/classes/module.bbclass b/meta/classes/module.bbclass
index e2174a1..2c1888c 100644
--- a/meta/classes/module.bbclass
+++ b/meta/classes/module.bbclass
@@ -28,7 +28,7 @@ module_pkg_postinst () {
 if [ -z "$D" ]; then
 	depmod -a ${KERNEL_VERSION}
 else
-	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
+	depmodwrapper -a -b $D ${KERNEL_VERSION}
 fi
 }
 
@@ -36,7 +36,7 @@ module_pkg_postrm () {
 if [ -z "$D" ]; then
 	depmod -a ${KERNEL_VERSION}
 else
-	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
+	depmodwrapper -a -b $D ${KERNEL_VERSION}
 fi
 }
 
diff --git a/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
new file mode 100644
index 0000000..646c4cd
--- /dev/null
+++ b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
@@ -0,0 +1,34 @@
+DESCRIPTION = "Depmod wrapper script"
+LICENSE = "MIT"
+PR = "r0"
+LIC_FILES_CHKSUM = "file://${COREBASE}/meta/COPYING.MIT;md5=3da9cfbcb788c80a0384361b4de20420"
+
+# We need to evaluate it to the final path for vardeps to
+# work properly.
+STAGING_KERNEL_DIR := "${STAGING_KERNEL_DIR}"
+
+do_install() {
+	install -d ${D}${bindir_crossscripts}/
+
+	cat > ${D}${bindir_crossscripts}/depmodwrapper << EOF
+#!/bin/sh
+# Expected to be called as: depmodwrapper -a KERNEL_VERSION
+if [ "\$1" != "-a" -a "\$2" != "-b" ]; then
+    echo "Usage: depmodwrapper -a -b rootfs KERNEL_VERSION" >&2
+    exit 1
+fi
+if [ ! -r ${STAGING_KERNEL_DIR}/System.map-\$4 ]; then
+    echo "Unable to read: ${STAGING_KERNEL_DIR}/System.map-\$4" >&2
+    exec env depmod "\$1" "\$2" "\$3" "\$4"
+else
+    exec env depmod "\$1" "\$2" "\$3" -F "${STAGING_KERNEL_DIR}/System.map-\$4" "\$4"
+fi
+EOF
+	chmod +x ${D}${bindir_crossscripts}/depmodwrapper
+}
+
+SYSROOT_PREPROCESS_FUNCS += "depmodwrapper_sysroot_preprocess"
+
+depmodwrapper_sysroot_preprocess () {
+	sysroot_stage_dir ${D}${bindir_crossscripts} ${SYSROOT_DESTDIR}${bindir_crossscripts}
+}
-- 
1.7.1




^ permalink raw reply related	[flat|nested] 8+ messages in thread

* Re: [PATCH 2/2] module.bbclass: Create a new depmodwrapper to assist cross-installs
  2013-02-28 18:09 ` [PATCH 2/2] module.bbclass: Create a new depmodwrapper to assist cross-installs Mark Hatle
@ 2013-02-28 19:12   ` Bruce Ashfield
  2013-02-28 19:40     ` Mark Hatle
  2013-02-28 20:53   ` Richard Purdie
  1 sibling, 1 reply; 8+ messages in thread
From: Bruce Ashfield @ 2013-02-28 19:12 UTC (permalink / raw)
  To: Mark Hatle; +Cc: Patches and discussions about the oe-core layer

On Thu, Feb 28, 2013 at 1:09 PM, Mark Hatle <mark.hatle@windriver.com> wrote:
> Previously the build path to STAGING_KERNEL_DIR was being embedded into the
> package post install scripts.  We avoid this behavior by generating a special
> depmodwrapper script.  This script contains that hard-coded path, ensuring
> that re-use of the sstate-cache (and/or packages) will always run through the
> wrapper generated by the current build with a checksum that includes
> STAGING_KERNEL_DIR.
>
> [ YOCTO #3962 ]
>
> Signed-off-by: Mark Hatle <mark.hatle@windriver.com>
> Signed-off-by: Bruce Ashfield <bruce.ashfield@windriver.com>
> ---
>  meta/classes/image.bbclass                         |    4 +-
>  meta/classes/kernel.bbclass                        |    8 ++--
>  meta/classes/module.bbclass                        |    4 +-
>  .../recipes-kernel/kmod/depmodwrapper-cross_1.0.bb |   34 ++++++++++++++++++++
>  4 files changed, 42 insertions(+), 8 deletions(-)
>  create mode 100644 meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
>
> diff --git a/meta/classes/image.bbclass b/meta/classes/image.bbclass
> index dd78acb..af17331 100644
> --- a/meta/classes/image.bbclass
> +++ b/meta/classes/image.bbclass
> @@ -10,7 +10,7 @@ inherit gzipnative
>
>  LICENSE = "MIT"
>  PACKAGES = ""
> -DEPENDS += "${MLPREFIX}qemuwrapper-cross"
> +DEPENDS += "${MLPREFIX}qemuwrapper-cross depmodwrapper-cross"
>  RDEPENDS += "${IMAGE_INSTALL} ${LINGUAS_INSTALL} ${NORMAL_FEATURE_INSTALL} ${ROOTFS_BOOTSTRAP_INSTALL}"
>  RRECOMMENDS += "${NORMAL_FEATURE_INSTALL_OPTIONAL}"
>
> @@ -283,7 +283,7 @@ fakeroot do_rootfs () {
>                 KERNEL_VERSION=`cat ${STAGING_KERNEL_DIR}/kernel-abiversion`
>
>                 mkdir -p ${IMAGE_ROOTFS}/lib/modules/$KERNEL_VERSION
> -               depmod -a -b ${IMAGE_ROOTFS} -F ${STAGING_KERNEL_DIR}/System.map-$KERNEL_VERSION $KERNEL_VERSION
> +               depmodwrapper -a -b ${IMAGE_ROOTFS} $KERNEL_VERSION
>         fi
>
>         ${IMAGE_PREPROCESS_COMMAND}
> diff --git a/meta/classes/kernel.bbclass b/meta/classes/kernel.bbclass
> index e8c585b..2bdc2fc 100644
> --- a/meta/classes/kernel.bbclass
> +++ b/meta/classes/kernel.bbclass
> @@ -1,7 +1,7 @@
>  inherit linux-kernel-base module_strip
>
>  PROVIDES += "virtual/kernel"
> -DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native"
> +DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native depmodwrapper-cross"
>
>  # we include gcc above, we dont need virtual/libc
>  INHIBIT_DEFAULT_DEPS = "1"
> @@ -272,7 +272,7 @@ if [ ! -e "$D/lib/modules/${KERNEL_VERSION}" ]; then
>         mkdir -p $D/lib/modules/${KERNEL_VERSION}
>  fi
>  if [ -n "$D" ]; then
> -       depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> +       depmodwrapper -a -b $D ${KERNEL_VERSION}
>  else
>         depmod -a ${KERNEL_VERSION}
>  fi
> @@ -282,7 +282,7 @@ pkg_postinst_modules () {
>  if [ -z "$D" ]; then
>         depmod -a ${KERNEL_VERSION}
>  else
> -       depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> +       depmodwrapper -a -b $D ${KERNEL_VERSION}
>  fi
>  }
>
> @@ -290,7 +290,7 @@ pkg_postrm_modules () {
>  if [ -z "$D" ]; then
>         depmod -a ${KERNEL_VERSION}
>  else
> -       depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> +       depmodwrapper -a -b $D ${KERNEL_VERSION}
>  fi
>  }
>
> diff --git a/meta/classes/module.bbclass b/meta/classes/module.bbclass
> index e2174a1..2c1888c 100644
> --- a/meta/classes/module.bbclass
> +++ b/meta/classes/module.bbclass
> @@ -28,7 +28,7 @@ module_pkg_postinst () {
>  if [ -z "$D" ]; then
>         depmod -a ${KERNEL_VERSION}
>  else
> -       depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> +       depmodwrapper -a -b $D ${KERNEL_VERSION}
>  fi
>  }
>
> @@ -36,7 +36,7 @@ module_pkg_postrm () {
>  if [ -z "$D" ]; then
>         depmod -a ${KERNEL_VERSION}
>  else
> -       depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> +       depmodwrapper -a -b $D ${KERNEL_VERSION}
>  fi
>  }
>
> diff --git a/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
> new file mode 100644
> index 0000000..646c4cd
> --- /dev/null
> +++ b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
> @@ -0,0 +1,34 @@
> +DESCRIPTION = "Depmod wrapper script"
> +LICENSE = "MIT"
> +PR = "r0"
> +LIC_FILES_CHKSUM = "file://${COREBASE}/meta/COPYING.MIT;md5=3da9cfbcb788c80a0384361b4de20420"
> +
> +# We need to evaluate it to the final path for vardeps to
> +# work properly.
> +STAGING_KERNEL_DIR := "${STAGING_KERNEL_DIR}"
> +
> +do_install() {
> +       install -d ${D}${bindir_crossscripts}/
> +
> +       cat > ${D}${bindir_crossscripts}/depmodwrapper << EOF
> +#!/bin/sh
> +# Expected to be called as: depmodwrapper -a KERNEL_VERSION

Can we remove the need for KERNEL_VERSION to be passed ? You are already
looking at ${STAGING_KERNEL_DIR}, so just pulling the kernel version
out of ${STAGING_KERNEL_DIR}/kernel-abiversion will reduce the chances
of mistakes.

Bruce


> +if [ "\$1" != "-a" -a "\$2" != "-b" ]; then
> +    echo "Usage: depmodwrapper -a -b rootfs KERNEL_VERSION" >&2
> +    exit 1
> +fi
> +if [ ! -r ${STAGING_KERNEL_DIR}/System.map-\$4 ]; then
> +    echo "Unable to read: ${STAGING_KERNEL_DIR}/System.map-\$4" >&2
> +    exec env depmod "\$1" "\$2" "\$3" "\$4"
> +else
> +    exec env depmod "\$1" "\$2" "\$3" -F "${STAGING_KERNEL_DIR}/System.map-\$4" "\$4"
> +fi
> +EOF
> +       chmod +x ${D}${bindir_crossscripts}/depmodwrapper
> +}
> +
> +SYSROOT_PREPROCESS_FUNCS += "depmodwrapper_sysroot_preprocess"
> +
> +depmodwrapper_sysroot_preprocess () {
> +       sysroot_stage_dir ${D}${bindir_crossscripts} ${SYSROOT_DESTDIR}${bindir_crossscripts}
> +}
> --
> 1.7.1
>
>
> _______________________________________________
> Openembedded-core mailing list
> Openembedded-core@lists.openembedded.org
> http://lists.linuxtogo.org/cgi-bin/mailman/listinfo/openembedded-core



--
"Thou shalt not follow the NULL pointer, for chaos and madness await
thee at its end"



^ permalink raw reply	[flat|nested] 8+ messages in thread

* Re: [PATCH 2/2] module.bbclass: Create a new depmodwrapper to assist cross-installs
  2013-02-28 19:12   ` Bruce Ashfield
@ 2013-02-28 19:40     ` Mark Hatle
  0 siblings, 0 replies; 8+ messages in thread
From: Mark Hatle @ 2013-02-28 19:40 UTC (permalink / raw)
  To: Bruce Ashfield; +Cc: Patches and discussions about the oe-core layer

On 2/28/13 1:12 PM, Bruce Ashfield wrote:
> On Thu, Feb 28, 2013 at 1:09 PM, Mark Hatle <mark.hatle@windriver.com> wrote:
>> Previously the build path to STAGING_KERNEL_DIR was being embedded into the
>> package post install scripts.  We avoid this behavior by generating a special
>> depmodwrapper script.  This script contains that hard-coded path, ensuring
>> that re-use of the sstate-cache (and/or packages) will always run through the
>> wrapper generated by the current build with a checksum that includes
>> STAGING_KERNEL_DIR.
>>
>> [ YOCTO #3962 ]
>>
>> Signed-off-by: Mark Hatle <mark.hatle@windriver.com>
>> Signed-off-by: Bruce Ashfield <bruce.ashfield@windriver.com>
>> ---
>>   meta/classes/image.bbclass                         |    4 +-
>>   meta/classes/kernel.bbclass                        |    8 ++--
>>   meta/classes/module.bbclass                        |    4 +-
>>   .../recipes-kernel/kmod/depmodwrapper-cross_1.0.bb |   34 ++++++++++++++++++++
>>   4 files changed, 42 insertions(+), 8 deletions(-)
>>   create mode 100644 meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
>>
>> diff --git a/meta/classes/image.bbclass b/meta/classes/image.bbclass
>> index dd78acb..af17331 100644
>> --- a/meta/classes/image.bbclass
>> +++ b/meta/classes/image.bbclass
>> @@ -10,7 +10,7 @@ inherit gzipnative
>>
>>   LICENSE = "MIT"
>>   PACKAGES = ""
>> -DEPENDS += "${MLPREFIX}qemuwrapper-cross"
>> +DEPENDS += "${MLPREFIX}qemuwrapper-cross depmodwrapper-cross"
>>   RDEPENDS += "${IMAGE_INSTALL} ${LINGUAS_INSTALL} ${NORMAL_FEATURE_INSTALL} ${ROOTFS_BOOTSTRAP_INSTALL}"
>>   RRECOMMENDS += "${NORMAL_FEATURE_INSTALL_OPTIONAL}"
>>
>> @@ -283,7 +283,7 @@ fakeroot do_rootfs () {
>>                  KERNEL_VERSION=`cat ${STAGING_KERNEL_DIR}/kernel-abiversion`
>>
>>                  mkdir -p ${IMAGE_ROOTFS}/lib/modules/$KERNEL_VERSION
>> -               depmod -a -b ${IMAGE_ROOTFS} -F ${STAGING_KERNEL_DIR}/System.map-$KERNEL_VERSION $KERNEL_VERSION
>> +               depmodwrapper -a -b ${IMAGE_ROOTFS} $KERNEL_VERSION
>>          fi
>>
>>          ${IMAGE_PREPROCESS_COMMAND}
>> diff --git a/meta/classes/kernel.bbclass b/meta/classes/kernel.bbclass
>> index e8c585b..2bdc2fc 100644
>> --- a/meta/classes/kernel.bbclass
>> +++ b/meta/classes/kernel.bbclass
>> @@ -1,7 +1,7 @@
>>   inherit linux-kernel-base module_strip
>>
>>   PROVIDES += "virtual/kernel"
>> -DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native"
>> +DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native depmodwrapper-cross"
>>
>>   # we include gcc above, we dont need virtual/libc
>>   INHIBIT_DEFAULT_DEPS = "1"
>> @@ -272,7 +272,7 @@ if [ ! -e "$D/lib/modules/${KERNEL_VERSION}" ]; then
>>          mkdir -p $D/lib/modules/${KERNEL_VERSION}
>>   fi
>>   if [ -n "$D" ]; then
>> -       depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
>> +       depmodwrapper -a -b $D ${KERNEL_VERSION}
>>   else
>>          depmod -a ${KERNEL_VERSION}
>>   fi
>> @@ -282,7 +282,7 @@ pkg_postinst_modules () {
>>   if [ -z "$D" ]; then
>>          depmod -a ${KERNEL_VERSION}
>>   else
>> -       depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
>> +       depmodwrapper -a -b $D ${KERNEL_VERSION}
>>   fi
>>   }
>>
>> @@ -290,7 +290,7 @@ pkg_postrm_modules () {
>>   if [ -z "$D" ]; then
>>          depmod -a ${KERNEL_VERSION}
>>   else
>> -       depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
>> +       depmodwrapper -a -b $D ${KERNEL_VERSION}
>>   fi
>>   }
>>
>> diff --git a/meta/classes/module.bbclass b/meta/classes/module.bbclass
>> index e2174a1..2c1888c 100644
>> --- a/meta/classes/module.bbclass
>> +++ b/meta/classes/module.bbclass
>> @@ -28,7 +28,7 @@ module_pkg_postinst () {
>>   if [ -z "$D" ]; then
>>          depmod -a ${KERNEL_VERSION}
>>   else
>> -       depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
>> +       depmodwrapper -a -b $D ${KERNEL_VERSION}
>>   fi
>>   }
>>
>> @@ -36,7 +36,7 @@ module_pkg_postrm () {
>>   if [ -z "$D" ]; then
>>          depmod -a ${KERNEL_VERSION}
>>   else
>> -       depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
>> +       depmodwrapper -a -b $D ${KERNEL_VERSION}
>>   fi
>>   }
>>
>> diff --git a/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
>> new file mode 100644
>> index 0000000..646c4cd
>> --- /dev/null
>> +++ b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
>> @@ -0,0 +1,34 @@
>> +DESCRIPTION = "Depmod wrapper script"
>> +LICENSE = "MIT"
>> +PR = "r0"
>> +LIC_FILES_CHKSUM = "file://${COREBASE}/meta/COPYING.MIT;md5=3da9cfbcb788c80a0384361b4de20420"
>> +
>> +# We need to evaluate it to the final path for vardeps to
>> +# work properly.
>> +STAGING_KERNEL_DIR := "${STAGING_KERNEL_DIR}"
>> +
>> +do_install() {
>> +       install -d ${D}${bindir_crossscripts}/
>> +
>> +       cat > ${D}${bindir_crossscripts}/depmodwrapper << EOF
>> +#!/bin/sh
>> +# Expected to be called as: depmodwrapper -a KERNEL_VERSION
>
> Can we remove the need for KERNEL_VERSION to be passed ? You are already
> looking at ${STAGING_KERNEL_DIR}, so just pulling the kernel version
> out of ${STAGING_KERNEL_DIR}/kernel-abiversion will reduce the chances
> of mistakes.

I did it this way specifically so that the KERNEL_VERSION that is already
embedded into the depmod call for the "target" install, is the same as the one
used for the cross-install.  My assumption is that if one works, the other will
work.

What I can do is simply check that kernel-abiversion and verify it's the same
value, and fail (cross) if it's not... Would that be reasonable?

> Bruce
>
>
>> +if [ "\$1" != "-a" -a "\$2" != "-b" ]; then
>> +    echo "Usage: depmodwrapper -a -b rootfs KERNEL_VERSION" >&2
>> +    exit 1
>> +fi
>> +if [ ! -r ${STAGING_KERNEL_DIR}/System.map-\$4 ]; then
>> +    echo "Unable to read: ${STAGING_KERNEL_DIR}/System.map-\$4" >&2
>> +    exec env depmod "\$1" "\$2" "\$3" "\$4"
>> +else
>> +    exec env depmod "\$1" "\$2" "\$3" -F "${STAGING_KERNEL_DIR}/System.map-\$4" "\$4"
>> +fi
>> +EOF
>> +       chmod +x ${D}${bindir_crossscripts}/depmodwrapper
>> +}
>> +
>> +SYSROOT_PREPROCESS_FUNCS += "depmodwrapper_sysroot_preprocess"
>> +
>> +depmodwrapper_sysroot_preprocess () {
>> +       sysroot_stage_dir ${D}${bindir_crossscripts} ${SYSROOT_DESTDIR}${bindir_crossscripts}
>> +}
>> --
>> 1.7.1
>>
>>
>> _______________________________________________
>> Openembedded-core mailing list
>> Openembedded-core@lists.openembedded.org
>> http://lists.linuxtogo.org/cgi-bin/mailman/listinfo/openembedded-core
>
>
>
> --
> "Thou shalt not follow the NULL pointer, for chaos and madness await
> thee at its end"
>




^ permalink raw reply	[flat|nested] 8+ messages in thread

* Re: [PATCH 2/2] module.bbclass: Create a new depmodwrapper to assist cross-installs
  2013-02-28 18:09 ` [PATCH 2/2] module.bbclass: Create a new depmodwrapper to assist cross-installs Mark Hatle
  2013-02-28 19:12   ` Bruce Ashfield
@ 2013-02-28 20:53   ` Richard Purdie
  2013-02-28 21:07     ` Mark Hatle
  1 sibling, 1 reply; 8+ messages in thread
From: Richard Purdie @ 2013-02-28 20:53 UTC (permalink / raw)
  To: Mark Hatle; +Cc: openembedded-core

On Thu, 2013-02-28 at 12:09 -0600, Mark Hatle wrote:
> Previously the build path to STAGING_KERNEL_DIR was being embedded into the
> package post install scripts.  We avoid this behavior by generating a special
> depmodwrapper script.  This script contains that hard-coded path, ensuring
> that re-use of the sstate-cache (and/or packages) will always run through the
> wrapper generated by the current build with a checksum that includes
> STAGING_KERNEL_DIR.
> 
> [ YOCTO #3962 ]
> 
> Signed-off-by: Mark Hatle <mark.hatle@windriver.com>
> Signed-off-by: Bruce Ashfield <bruce.ashfield@windriver.com>
> ---
>  meta/classes/image.bbclass                         |    4 +-
>  meta/classes/kernel.bbclass                        |    8 ++--
>  meta/classes/module.bbclass                        |    4 +-
>  .../recipes-kernel/kmod/depmodwrapper-cross_1.0.bb |   34 ++++++++++++++++++++
>  4 files changed, 42 insertions(+), 8 deletions(-)
>  create mode 100644 meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
> 
> diff --git a/meta/classes/image.bbclass b/meta/classes/image.bbclass
> index dd78acb..af17331 100644
> --- a/meta/classes/image.bbclass
> +++ b/meta/classes/image.bbclass
> @@ -10,7 +10,7 @@ inherit gzipnative
>  
>  LICENSE = "MIT"
>  PACKAGES = ""
> -DEPENDS += "${MLPREFIX}qemuwrapper-cross"
> +DEPENDS += "${MLPREFIX}qemuwrapper-cross depmodwrapper-cross"
>  RDEPENDS += "${IMAGE_INSTALL} ${LINGUAS_INSTALL} ${NORMAL_FEATURE_INSTALL} ${ROOTFS_BOOTSTRAP_INSTALL}"
>  RRECOMMENDS += "${NORMAL_FEATURE_INSTALL_OPTIONAL}"
>  
> @@ -283,7 +283,7 @@ fakeroot do_rootfs () {
>  		KERNEL_VERSION=`cat ${STAGING_KERNEL_DIR}/kernel-abiversion`
>  
>  		mkdir -p ${IMAGE_ROOTFS}/lib/modules/$KERNEL_VERSION
> -		depmod -a -b ${IMAGE_ROOTFS} -F ${STAGING_KERNEL_DIR}/System.map-$KERNEL_VERSION $KERNEL_VERSION
> +		depmodwrapper -a -b ${IMAGE_ROOTFS} $KERNEL_VERSION
>  	fi
>  
>  	${IMAGE_PREPROCESS_COMMAND}
> diff --git a/meta/classes/kernel.bbclass b/meta/classes/kernel.bbclass
> index e8c585b..2bdc2fc 100644
> --- a/meta/classes/kernel.bbclass
> +++ b/meta/classes/kernel.bbclass
> @@ -1,7 +1,7 @@
>  inherit linux-kernel-base module_strip
>  
>  PROVIDES += "virtual/kernel"
> -DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native"
> +DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native depmodwrapper-cross"
>  
>  # we include gcc above, we dont need virtual/libc
>  INHIBIT_DEFAULT_DEPS = "1"
> @@ -272,7 +272,7 @@ if [ ! -e "$D/lib/modules/${KERNEL_VERSION}" ]; then
>  	mkdir -p $D/lib/modules/${KERNEL_VERSION}
>  fi
>  if [ -n "$D" ]; then
> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
>  else
>  	depmod -a ${KERNEL_VERSION}
>  fi
> @@ -282,7 +282,7 @@ pkg_postinst_modules () {
>  if [ -z "$D" ]; then
>  	depmod -a ${KERNEL_VERSION}
>  else
> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
>  fi
>  }
>  
> @@ -290,7 +290,7 @@ pkg_postrm_modules () {
>  if [ -z "$D" ]; then
>  	depmod -a ${KERNEL_VERSION}
>  else
> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
>  fi
>  }
>  
> diff --git a/meta/classes/module.bbclass b/meta/classes/module.bbclass
> index e2174a1..2c1888c 100644
> --- a/meta/classes/module.bbclass
> +++ b/meta/classes/module.bbclass
> @@ -28,7 +28,7 @@ module_pkg_postinst () {
>  if [ -z "$D" ]; then
>  	depmod -a ${KERNEL_VERSION}
>  else
> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
>  fi
>  }
>  
> @@ -36,7 +36,7 @@ module_pkg_postrm () {
>  if [ -z "$D" ]; then
>  	depmod -a ${KERNEL_VERSION}
>  else
> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
>  fi
>  }
>  
> diff --git a/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
> new file mode 100644
> index 0000000..646c4cd
> --- /dev/null
> +++ b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
> @@ -0,0 +1,34 @@
> +DESCRIPTION = "Depmod wrapper script"
> +LICENSE = "MIT"
> +PR = "r0"
> +LIC_FILES_CHKSUM = "file://${COREBASE}/meta/COPYING.MIT;md5=3da9cfbcb788c80a0384361b4de20420"
> +
> +# We need to evaluate it to the final path for vardeps to
> +# work properly.
> +STAGING_KERNEL_DIR := "${STAGING_KERNEL_DIR}"

Please get rid of the above line. Really. You do not need to do this.
I've told you this already and I do mean it. 

No, it won't show up in the sstate dependencies directly but the sed run
over text files containing "STAGING_DIR" expressions will take care of
relocating it, hence it doesn't need to be there.

If that doesn't happen, please say why the sed expressions don't catch
it.

Cheers,

Richard

> +do_install() {
> +	install -d ${D}${bindir_crossscripts}/
> +
> +	cat > ${D}${bindir_crossscripts}/depmodwrapper << EOF
> +#!/bin/sh
> +# Expected to be called as: depmodwrapper -a KERNEL_VERSION
> +if [ "\$1" != "-a" -a "\$2" != "-b" ]; then
> +    echo "Usage: depmodwrapper -a -b rootfs KERNEL_VERSION" >&2
> +    exit 1
> +fi
> +if [ ! -r ${STAGING_KERNEL_DIR}/System.map-\$4 ]; then
> +    echo "Unable to read: ${STAGING_KERNEL_DIR}/System.map-\$4" >&2
> +    exec env depmod "\$1" "\$2" "\$3" "\$4"
> +else
> +    exec env depmod "\$1" "\$2" "\$3" -F "${STAGING_KERNEL_DIR}/System.map-\$4" "\$4"
> +fi
> +EOF
> +	chmod +x ${D}${bindir_crossscripts}/depmodwrapper
> +}
> +
> +SYSROOT_PREPROCESS_FUNCS += "depmodwrapper_sysroot_preprocess"
> +
> +depmodwrapper_sysroot_preprocess () {
> +	sysroot_stage_dir ${D}${bindir_crossscripts} ${SYSROOT_DESTDIR}${bindir_crossscripts}
> +}





^ permalink raw reply	[flat|nested] 8+ messages in thread

* Re: [PATCH 2/2] module.bbclass: Create a new depmodwrapper to assist cross-installs
  2013-02-28 20:53   ` Richard Purdie
@ 2013-02-28 21:07     ` Mark Hatle
  2013-02-28 21:23       ` Martin Jansa
  0 siblings, 1 reply; 8+ messages in thread
From: Mark Hatle @ 2013-02-28 21:07 UTC (permalink / raw)
  To: Richard Purdie; +Cc: openembedded-core

On 2/28/13 2:53 PM, Richard Purdie wrote:
> On Thu, 2013-02-28 at 12:09 -0600, Mark Hatle wrote:
>> Previously the build path to STAGING_KERNEL_DIR was being embedded into the
>> package post install scripts.  We avoid this behavior by generating a special
>> depmodwrapper script.  This script contains that hard-coded path, ensuring
>> that re-use of the sstate-cache (and/or packages) will always run through the
>> wrapper generated by the current build with a checksum that includes
>> STAGING_KERNEL_DIR.
>>
>> [ YOCTO #3962 ]
>>
>> Signed-off-by: Mark Hatle <mark.hatle@windriver.com>
>> Signed-off-by: Bruce Ashfield <bruce.ashfield@windriver.com>
>> ---
>>   meta/classes/image.bbclass                         |    4 +-
>>   meta/classes/kernel.bbclass                        |    8 ++--
>>   meta/classes/module.bbclass                        |    4 +-
>>   .../recipes-kernel/kmod/depmodwrapper-cross_1.0.bb |   34 ++++++++++++++++++++
>>   4 files changed, 42 insertions(+), 8 deletions(-)
>>   create mode 100644 meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
>>
>> diff --git a/meta/classes/image.bbclass b/meta/classes/image.bbclass
>> index dd78acb..af17331 100644
>> --- a/meta/classes/image.bbclass
>> +++ b/meta/classes/image.bbclass
>> @@ -10,7 +10,7 @@ inherit gzipnative
>>
>>   LICENSE = "MIT"
>>   PACKAGES = ""
>> -DEPENDS += "${MLPREFIX}qemuwrapper-cross"
>> +DEPENDS += "${MLPREFIX}qemuwrapper-cross depmodwrapper-cross"
>>   RDEPENDS += "${IMAGE_INSTALL} ${LINGUAS_INSTALL} ${NORMAL_FEATURE_INSTALL} ${ROOTFS_BOOTSTRAP_INSTALL}"
>>   RRECOMMENDS += "${NORMAL_FEATURE_INSTALL_OPTIONAL}"
>>
>> @@ -283,7 +283,7 @@ fakeroot do_rootfs () {
>>   		KERNEL_VERSION=`cat ${STAGING_KERNEL_DIR}/kernel-abiversion`
>>
>>   		mkdir -p ${IMAGE_ROOTFS}/lib/modules/$KERNEL_VERSION
>> -		depmod -a -b ${IMAGE_ROOTFS} -F ${STAGING_KERNEL_DIR}/System.map-$KERNEL_VERSION $KERNEL_VERSION
>> +		depmodwrapper -a -b ${IMAGE_ROOTFS} $KERNEL_VERSION
>>   	fi
>>
>>   	${IMAGE_PREPROCESS_COMMAND}
>> diff --git a/meta/classes/kernel.bbclass b/meta/classes/kernel.bbclass
>> index e8c585b..2bdc2fc 100644
>> --- a/meta/classes/kernel.bbclass
>> +++ b/meta/classes/kernel.bbclass
>> @@ -1,7 +1,7 @@
>>   inherit linux-kernel-base module_strip
>>
>>   PROVIDES += "virtual/kernel"
>> -DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native"
>> +DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native depmodwrapper-cross"
>>
>>   # we include gcc above, we dont need virtual/libc
>>   INHIBIT_DEFAULT_DEPS = "1"
>> @@ -272,7 +272,7 @@ if [ ! -e "$D/lib/modules/${KERNEL_VERSION}" ]; then
>>   	mkdir -p $D/lib/modules/${KERNEL_VERSION}
>>   fi
>>   if [ -n "$D" ]; then
>> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
>> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
>>   else
>>   	depmod -a ${KERNEL_VERSION}
>>   fi
>> @@ -282,7 +282,7 @@ pkg_postinst_modules () {
>>   if [ -z "$D" ]; then
>>   	depmod -a ${KERNEL_VERSION}
>>   else
>> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
>> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
>>   fi
>>   }
>>
>> @@ -290,7 +290,7 @@ pkg_postrm_modules () {
>>   if [ -z "$D" ]; then
>>   	depmod -a ${KERNEL_VERSION}
>>   else
>> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
>> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
>>   fi
>>   }
>>
>> diff --git a/meta/classes/module.bbclass b/meta/classes/module.bbclass
>> index e2174a1..2c1888c 100644
>> --- a/meta/classes/module.bbclass
>> +++ b/meta/classes/module.bbclass
>> @@ -28,7 +28,7 @@ module_pkg_postinst () {
>>   if [ -z "$D" ]; then
>>   	depmod -a ${KERNEL_VERSION}
>>   else
>> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
>> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
>>   fi
>>   }
>>
>> @@ -36,7 +36,7 @@ module_pkg_postrm () {
>>   if [ -z "$D" ]; then
>>   	depmod -a ${KERNEL_VERSION}
>>   else
>> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
>> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
>>   fi
>>   }
>>
>> diff --git a/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
>> new file mode 100644
>> index 0000000..646c4cd
>> --- /dev/null
>> +++ b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
>> @@ -0,0 +1,34 @@
>> +DESCRIPTION = "Depmod wrapper script"
>> +LICENSE = "MIT"
>> +PR = "r0"
>> +LIC_FILES_CHKSUM = "file://${COREBASE}/meta/COPYING.MIT;md5=3da9cfbcb788c80a0384361b4de20420"
>> +
>> +# We need to evaluate it to the final path for vardeps to
>> +# work properly.
>> +STAGING_KERNEL_DIR := "${STAGING_KERNEL_DIR}"
>
> Please get rid of the above line. Really. You do not need to do this.
> I've told you this already and I do mean it.
>
> No, it won't show up in the sstate dependencies directly but the sed run
> over text files containing "STAGING_DIR" expressions will take care of
> relocating it, hence it doesn't need to be there.
>
> If that doesn't happen, please say why the sed expressions don't catch
> it.

Without that line, the thing was never modified from what was installed into the 
sysroot.  I have no idea what is supposed to change the values, but it wasn't 
working.

Very easy to reproduce with master, take that code and run it in one build, 
share the sstate, run it in the second.  Without the := bit, it keeps using the 
old path.  (I spent almost 4 hours on this yesterday before finally doing the := 
to make it work.  I'd rather the sstate code "make it work", but it wasn't.)

--Mark

> Cheers,
>
> Richard
>
>> +do_install() {
>> +	install -d ${D}${bindir_crossscripts}/
>> +
>> +	cat > ${D}${bindir_crossscripts}/depmodwrapper << EOF
>> +#!/bin/sh
>> +# Expected to be called as: depmodwrapper -a KERNEL_VERSION
>> +if [ "\$1" != "-a" -a "\$2" != "-b" ]; then
>> +    echo "Usage: depmodwrapper -a -b rootfs KERNEL_VERSION" >&2
>> +    exit 1
>> +fi
>> +if [ ! -r ${STAGING_KERNEL_DIR}/System.map-\$4 ]; then
>> +    echo "Unable to read: ${STAGING_KERNEL_DIR}/System.map-\$4" >&2
>> +    exec env depmod "\$1" "\$2" "\$3" "\$4"
>> +else
>> +    exec env depmod "\$1" "\$2" "\$3" -F "${STAGING_KERNEL_DIR}/System.map-\$4" "\$4"
>> +fi
>> +EOF
>> +	chmod +x ${D}${bindir_crossscripts}/depmodwrapper
>> +}
>> +
>> +SYSROOT_PREPROCESS_FUNCS += "depmodwrapper_sysroot_preprocess"
>> +
>> +depmodwrapper_sysroot_preprocess () {
>> +	sysroot_stage_dir ${D}${bindir_crossscripts} ${SYSROOT_DESTDIR}${bindir_crossscripts}
>> +}
>
>




^ permalink raw reply	[flat|nested] 8+ messages in thread

* Re: [PATCH 2/2] module.bbclass: Create a new depmodwrapper to assist cross-installs
  2013-02-28 21:07     ` Mark Hatle
@ 2013-02-28 21:23       ` Martin Jansa
  0 siblings, 0 replies; 8+ messages in thread
From: Martin Jansa @ 2013-02-28 21:23 UTC (permalink / raw)
  To: Mark Hatle; +Cc: openembedded-core

[-- Attachment #1: Type: text/plain, Size: 7463 bytes --]

On Thu, Feb 28, 2013 at 03:07:19PM -0600, Mark Hatle wrote:
> On 2/28/13 2:53 PM, Richard Purdie wrote:
> > On Thu, 2013-02-28 at 12:09 -0600, Mark Hatle wrote:
> >> Previously the build path to STAGING_KERNEL_DIR was being embedded into the
> >> package post install scripts.  We avoid this behavior by generating a special
> >> depmodwrapper script.  This script contains that hard-coded path, ensuring
> >> that re-use of the sstate-cache (and/or packages) will always run through the
> >> wrapper generated by the current build with a checksum that includes
> >> STAGING_KERNEL_DIR.
> >>
> >> [ YOCTO #3962 ]
> >>
> >> Signed-off-by: Mark Hatle <mark.hatle@windriver.com>
> >> Signed-off-by: Bruce Ashfield <bruce.ashfield@windriver.com>
> >> ---
> >>   meta/classes/image.bbclass                         |    4 +-
> >>   meta/classes/kernel.bbclass                        |    8 ++--
> >>   meta/classes/module.bbclass                        |    4 +-
> >>   .../recipes-kernel/kmod/depmodwrapper-cross_1.0.bb |   34 ++++++++++++++++++++
> >>   4 files changed, 42 insertions(+), 8 deletions(-)
> >>   create mode 100644 meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
> >>
> >> diff --git a/meta/classes/image.bbclass b/meta/classes/image.bbclass
> >> index dd78acb..af17331 100644
> >> --- a/meta/classes/image.bbclass
> >> +++ b/meta/classes/image.bbclass
> >> @@ -10,7 +10,7 @@ inherit gzipnative
> >>
> >>   LICENSE = "MIT"
> >>   PACKAGES = ""
> >> -DEPENDS += "${MLPREFIX}qemuwrapper-cross"
> >> +DEPENDS += "${MLPREFIX}qemuwrapper-cross depmodwrapper-cross"
> >>   RDEPENDS += "${IMAGE_INSTALL} ${LINGUAS_INSTALL} ${NORMAL_FEATURE_INSTALL} ${ROOTFS_BOOTSTRAP_INSTALL}"
> >>   RRECOMMENDS += "${NORMAL_FEATURE_INSTALL_OPTIONAL}"
> >>
> >> @@ -283,7 +283,7 @@ fakeroot do_rootfs () {
> >>   		KERNEL_VERSION=`cat ${STAGING_KERNEL_DIR}/kernel-abiversion`
> >>
> >>   		mkdir -p ${IMAGE_ROOTFS}/lib/modules/$KERNEL_VERSION
> >> -		depmod -a -b ${IMAGE_ROOTFS} -F ${STAGING_KERNEL_DIR}/System.map-$KERNEL_VERSION $KERNEL_VERSION
> >> +		depmodwrapper -a -b ${IMAGE_ROOTFS} $KERNEL_VERSION
> >>   	fi
> >>
> >>   	${IMAGE_PREPROCESS_COMMAND}
> >> diff --git a/meta/classes/kernel.bbclass b/meta/classes/kernel.bbclass
> >> index e8c585b..2bdc2fc 100644
> >> --- a/meta/classes/kernel.bbclass
> >> +++ b/meta/classes/kernel.bbclass
> >> @@ -1,7 +1,7 @@
> >>   inherit linux-kernel-base module_strip
> >>
> >>   PROVIDES += "virtual/kernel"
> >> -DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native"
> >> +DEPENDS += "virtual/${TARGET_PREFIX}gcc kmod-native depmodwrapper-cross"
> >>
> >>   # we include gcc above, we dont need virtual/libc
> >>   INHIBIT_DEFAULT_DEPS = "1"
> >> @@ -272,7 +272,7 @@ if [ ! -e "$D/lib/modules/${KERNEL_VERSION}" ]; then
> >>   	mkdir -p $D/lib/modules/${KERNEL_VERSION}
> >>   fi
> >>   if [ -n "$D" ]; then
> >> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> >> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
> >>   else
> >>   	depmod -a ${KERNEL_VERSION}
> >>   fi
> >> @@ -282,7 +282,7 @@ pkg_postinst_modules () {
> >>   if [ -z "$D" ]; then
> >>   	depmod -a ${KERNEL_VERSION}
> >>   else
> >> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> >> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
> >>   fi
> >>   }
> >>
> >> @@ -290,7 +290,7 @@ pkg_postrm_modules () {
> >>   if [ -z "$D" ]; then
> >>   	depmod -a ${KERNEL_VERSION}
> >>   else
> >> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> >> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
> >>   fi
> >>   }
> >>
> >> diff --git a/meta/classes/module.bbclass b/meta/classes/module.bbclass
> >> index e2174a1..2c1888c 100644
> >> --- a/meta/classes/module.bbclass
> >> +++ b/meta/classes/module.bbclass
> >> @@ -28,7 +28,7 @@ module_pkg_postinst () {
> >>   if [ -z "$D" ]; then
> >>   	depmod -a ${KERNEL_VERSION}
> >>   else
> >> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> >> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
> >>   fi
> >>   }
> >>
> >> @@ -36,7 +36,7 @@ module_pkg_postrm () {
> >>   if [ -z "$D" ]; then
> >>   	depmod -a ${KERNEL_VERSION}
> >>   else
> >> -	depmod -a -b $D -F ${STAGING_KERNEL_DIR}/System.map-${KERNEL_VERSION} ${KERNEL_VERSION}
> >> +	depmodwrapper -a -b $D ${KERNEL_VERSION}
> >>   fi
> >>   }
> >>
> >> diff --git a/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
> >> new file mode 100644
> >> index 0000000..646c4cd
> >> --- /dev/null
> >> +++ b/meta/recipes-kernel/kmod/depmodwrapper-cross_1.0.bb
> >> @@ -0,0 +1,34 @@
> >> +DESCRIPTION = "Depmod wrapper script"
> >> +LICENSE = "MIT"
> >> +PR = "r0"
> >> +LIC_FILES_CHKSUM = "file://${COREBASE}/meta/COPYING.MIT;md5=3da9cfbcb788c80a0384361b4de20420"
> >> +
> >> +# We need to evaluate it to the final path for vardeps to
> >> +# work properly.
> >> +STAGING_KERNEL_DIR := "${STAGING_KERNEL_DIR}"
> >
> > Please get rid of the above line. Really. You do not need to do this.
> > I've told you this already and I do mean it.
> >
> > No, it won't show up in the sstate dependencies directly but the sed run
> > over text files containing "STAGING_DIR" expressions will take care of
> > relocating it, hence it doesn't need to be there.
> >
> > If that doesn't happen, please say why the sed expressions don't catch
> > it.
> 
> Without that line, the thing was never modified from what was installed into the 
> sysroot.  I have no idea what is supposed to change the values, but it wasn't 
> working.
> 
> Very easy to reproduce with master, take that code and run it in one build, 
> share the sstate, run it in the second.  Without the := bit, it keeps using the 
> old path.  (I spent almost 4 hours on this yesterday before finally doing the := 
> to make it work.  I'd rather the sstate code "make it work", but it wasn't.)

Did you append depmodwrapper to SSTATE_SCAN_FILES?

> --Mark
> 
> > Cheers,
> >
> > Richard
> >
> >> +do_install() {
> >> +	install -d ${D}${bindir_crossscripts}/
> >> +
> >> +	cat > ${D}${bindir_crossscripts}/depmodwrapper << EOF
> >> +#!/bin/sh
> >> +# Expected to be called as: depmodwrapper -a KERNEL_VERSION
> >> +if [ "\$1" != "-a" -a "\$2" != "-b" ]; then
> >> +    echo "Usage: depmodwrapper -a -b rootfs KERNEL_VERSION" >&2
> >> +    exit 1
> >> +fi
> >> +if [ ! -r ${STAGING_KERNEL_DIR}/System.map-\$4 ]; then
> >> +    echo "Unable to read: ${STAGING_KERNEL_DIR}/System.map-\$4" >&2
> >> +    exec env depmod "\$1" "\$2" "\$3" "\$4"
> >> +else
> >> +    exec env depmod "\$1" "\$2" "\$3" -F "${STAGING_KERNEL_DIR}/System.map-\$4" "\$4"
> >> +fi
> >> +EOF
> >> +	chmod +x ${D}${bindir_crossscripts}/depmodwrapper
> >> +}
> >> +
> >> +SYSROOT_PREPROCESS_FUNCS += "depmodwrapper_sysroot_preprocess"
> >> +
> >> +depmodwrapper_sysroot_preprocess () {
> >> +	sysroot_stage_dir ${D}${bindir_crossscripts} ${SYSROOT_DESTDIR}${bindir_crossscripts}
> >> +}
> >
> >
> 
> 
> _______________________________________________
> Openembedded-core mailing list
> Openembedded-core@lists.openembedded.org
> http://lists.linuxtogo.org/cgi-bin/mailman/listinfo/openembedded-core

-- 
Martin 'JaMa' Jansa     jabber: Martin.Jansa@gmail.com

[-- Attachment #2: Digital signature --]
[-- Type: application/pgp-signature, Size: 205 bytes --]

^ permalink raw reply	[flat|nested] 8+ messages in thread

end of thread, other threads:[~2013-02-28 21:40 UTC | newest]

Thread overview: 8+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2013-02-28 18:09 [PATCH 0/2] kernel module fixes Mark Hatle
2013-02-28 18:09 ` [PATCH 1/2] kernel.bbclass: Add missing modules.order and modules.builtins Mark Hatle
2013-02-28 18:09 ` [PATCH 2/2] module.bbclass: Create a new depmodwrapper to assist cross-installs Mark Hatle
2013-02-28 19:12   ` Bruce Ashfield
2013-02-28 19:40     ` Mark Hatle
2013-02-28 20:53   ` Richard Purdie
2013-02-28 21:07     ` Mark Hatle
2013-02-28 21:23       ` Martin Jansa

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox